<template src="./template.html"></template>

<script lang="ts">
import { getModule, Watch } from "nuxt-property-decorator";
import { Vue, Component, Prop } from "vue-property-decorator";
import CountryFlag from "vue-country-flag";
import axios from "axios";
import { apiErrorHandler, redirectPage } from "@/utils/apiHanlers";
import { api } from "~/common/constaint";
import _ from "lodash";
var momentz = require("moment-timezone");
var moment = require("moment");
//@ts-ignore
import jsonCountry from "@/locales/countryCode.json";
//@ts-ignore
import jsonProvince from "@/locales/provinceCode.json";
//@ts-ignore
import listCountry from "@/locales/listCountry.json";
interface IQueryAdminAnalytics {
  page: number;
  limit: number;
  search: string;
  from?: number;
  to?: number;
  timezone?: string;
  storeId?: string;
  productId?: string;
  sellerId?: string;
  isAbandon?: boolean;
}
@Component({})
export default class AdminRevenueListComponent extends Vue {
  @Prop()
  tab!: number;

  @Prop()
  dateStart!: string;

  @Prop()
  dateEnd!: string;

  @Prop()
  listData!: any;

  @Prop()
  isAbandonedMail!: boolean;

  config = {
    page: 1,
    limit: 15,
    search: "",
  };
  totalPage: number = 0;
  page = 1;

  name = "";
  storeId = "";
  productId = "";
  sellerId = "";

  get timeActive() {
    return this.$store.state.setting.timeActive;
  }

  set timeActive(value: string) {
    this.$store.commit("setting/setTimeActive", value);
  }

  get timezone() {
    return this.$store.state.setting.timezone;
  }

  get from() {
    return this.$store.state.setting.from;
  }

  get to() {
    return this.$store.state.setting.to;
  }

  setDestroy() {
    this.listOrder = [];
    this.listOrderExport = [];
    this.json_data = [];
  }

  listOrder = [];
  listOrderExport = [];
  dialogFullScreen = false;
  loadingTable = false;
  loadingExport = false;
  settings = {};

  json_fields = {
    "Order Name": "orderName",
    Sku: "sku",
    "Product Name": "productName",
    "Variant Name": "variantName",
    Quantity: "quantity",
    "Item Status": "itemStatus",
    "Delivery Status": "deliveryStatus",
    "Last Status Updated At": "lastStatusUpdatedAt",
    "Paid At": "paidAt",
    "Processing At": "progressingAt",
    "Fulfilled At": "fulfilledAt",
    "Tracking Number": "trackingNumber",
    "Tracking Status": "trackingStatus",
    "Unit Price": "unitPrice",
    Subtotal: "subTotal",
    "Shipping Price": "shippingPrice",
    "Discount Price": "discountPrice",
    "Total Amount": "totalAmount",
    Refund: "refund",
    "Buyer Name": "buyerName",
    Email: "email",
    "Shipping Address 1": "shippingAddress1",
    "Shipping Address 2": "shippingAddress2",
    "Shipping Phone": "shippingPhone",
    "Shipping City": "shippingCity",
    "Shipping Zip": "shippingZip",
    "Shipping Province": "shippingProvince",
    "Shipping Country": "shippingCountry",
    "Shipping Country Code": "shippingCountryCode",
    "Shipping Province Code": "shippingProvinceCode",
    "Payment Gateway ID": "paymentGateWayId",
    "Gateway Name": "gatewayName",
    "Gateway Type": "gatewayType",
    "Seller Email": "sellerEmail",
    Domain: "domain",
    "Transaction Id": "transactionId",
  };
  json_data: any = [];
  json_meta = [
    [
      {
        key: "charset",
        value: "utf-8",
      },
    ],
  ];

  sortAddToCart = false;
  sortInitiateCheckout = false;
  sortCheckout = false;
  sortRevenueTotal = false;
  sortPurchase = false;
  sortTip = false;
  sortRefund = false;
  sortProductCost = false;

  onSortTableHighToLow(insert: string) {
    // const listData = [...this.listData].length - 1;

    const elemLast = this.listData.splice(this.listData.length - 1, 1);
    this.listData = this.$utils.sortList(this.listData, insert, "highToLow");
    this.$nextTick(() => {
      this.listData = [...this.listData, ...elemLast];
    });

    // if (this.tab === 0) {
    //   const elemLast = this.listData.splice(this.listData.length - 1, 1);
    //   this.listData = this.$utils.sortList(this.listData, insert, "highToLow");
    //   this.$nextTick(() => {
    //     this.listData = [...this.listData, ...elemLast];
    //   });
    // } else {
    //   // const elemLast = [...this.listData];
    //   this.listData = this.$utils.sortList(this.listData, insert, "highToLow");
    //   this.$nextTick(() => {
    //     this.listData = [...this.listData];
    //   });
    //   // this.$nextTick(() => {
    //   //   this.listData = [...this.listData, ...elemLast];
    //   // });
    // }
    // this.listData = this.$utils.sortList(listData, insert, "highToLow");
    if (insert === "addToCart") {
      this.sortAddToCart = false;
    }
    if (insert === "checkout") {
      this.sortCheckout = false;
    }

    if (insert === "goCheckout") {
      this.sortInitiateCheckout = false;
    }

    if (insert === "revenueTotal") {
      this.sortRevenueTotal = false;
    }
    if (insert === "purchase") {
      this.sortPurchase = false;
    }
    if (insert === "tip") {
      this.sortTip = false;
    }
    if (insert === "refund") {
      this.sortRefund = false;
    }
    if (insert === "productCost") {
      this.sortProductCost = false;
    }
  }
  onSortTableLowToHigh(insert: string) {
    // const listData = [...this.listData];
    // this.listData = this.$utils.sortList(listData, insert, "lowToHigh");

    const elemLast = this.listData.splice(this.listData.length - 1, 1);
    this.listData = this.$utils.sortList(this.listData, insert, "lowToHigh");
    this.$nextTick(() => {
      this.listData = [...this.listData, ...elemLast];
    });

    // if (this.tab === 0) {
    //   const elemLast = this.listData.splice(this.listData.length - 1, 1);
    //   this.listData = this.$utils.sortList(this.listData, insert, "lowToHigh");
    //   this.$nextTick(() => {
    //     this.listData = [...this.listData, ...elemLast];
    //   });
    // } else {
    //   // const elemLast = [...this.listData];
    //   this.listData = this.$utils.sortList(this.listData, insert, "lowToHigh");
    //   this.$nextTick(() => {
    //     this.listData = [...this.listData];
    //   });
    //   // this.$nextTick(() => {
    //   //   this.listData = [...this.listData, ...elemLast];
    //   // });
    // }
    this.checkValueSort(insert);
  }

  checkValueSort(insert: string) {
    this.sortAddToCart = insert === "addToCart";
    this.sortInitiateCheckout = insert === "goCheckout";
    this.sortCheckout = insert === "checkout";
    this.sortRevenueTotal = insert === "revenueTotal";
    this.sortPurchase = insert === "purchase";
    this.sortTip = insert === "tip";
    this.sortRefund = insert === "refund";
    this.sortProductCost = insert === "productCost";
  }

  mounted() {
    const siteInfo = _.cloneDeep(this.$store.state.setting.siteInfo);
    if (siteInfo) {
      this.settings = siteInfo;
    }
  }

  $reset() {
    this.config = {
      page: 1,
      limit: 15,
      search: "",
    };
    this.totalPage = 0;
    this.page = 1;
    this.storeId = "";
    this.productId = "";
    this.sellerId = "";
    this.listOrder = [];
    this.listOrderExport = [];
  }

  fetchData() {
    for (let order of this.listOrderExport) {
      if (order) {
        this.onParseListExport(order);
      }
    }
  }

  onParseListExport(findOrder?: any) {
    let listVariant;
    let listProduct;
    let listQuantity;
    let listSku;
    let listSlug;
    if (findOrder?.listSelectedProductId?.length) {
      listVariant = findOrder.listSelectedProductId
        .map((product: any) => product?.listValue)
        .join("\n");
      listProduct = findOrder.listSelectedProductId
        .map((product: any) => product?.productName)
        .join("\n");
      listQuantity = findOrder.listSelectedProductId
        .map((product: any) => product?.quantity)
        .join("\n");
      listSku = findOrder.listSelectedProductId
        .map((product: any) => {
          return product?.sku;
        })
        .join("\n");
      listSlug = findOrder.listSelectedProductId
        .map((product: any) => product?.slug)
        .join("\n");
    }
    if (findOrder && findOrder.shippingAddress) {
      let payment = "";
      if (findOrder?.paypal?.paymentID) {
        payment = "Paypal";
      } else if (findOrder?.stripe) {
        payment = "Stripe";
      }
      let itemStatus = "";
      if (findOrder.orderStatus === "processing") itemStatus = "Processing";
      else if (findOrder.orderStatus === "pending") itemStatus = "Pending";
      else if (findOrder.orderStatus === "canceled") itemStatus = "Canceled";
      else if (findOrder.orderStatus === "fulfilled") itemStatus = "Fulfilled";

      let deliveryStatus = "";
      if (findOrder.shippingStatus === 1) deliveryStatus = "TRACKING_PAID";
      else if (findOrder.shippingStatus === 2)
        deliveryStatus = "TRACKING_AVAILABLE";
      else if (findOrder.shippingStatus === 3)
        deliveryStatus = "TRACKING_ONLINE";
      else if (findOrder.shippingStatus === 4)
        deliveryStatus = "TRACKING_DELIVERY&GUARANTEE";

      const {
        address,
        apartment,
        city,
        companyName,
        country,
        email,
        firstName,
        lastName,
        phoneNumber,
        state,
        zipCode,
      } = findOrder.shippingAddress;
      const { listSelectedProductId } = findOrder;
      const findCountry = listCountry.find(
        (qg: any) => qg.code === country || qg.name === country
      );
      if (listSelectedProductId.length === 1) {
        //@ts-ignore
        this.json_data.push({
          orderName: findOrder.orderCode,
          sku: listSku,
          productName: listProduct || "",
          variantName: listVariant || "",
          quantity: listQuantity || "",
          itemStatus,
          deliveryStatus,
          lastStatusUpdatedAt:
            findOrder.updatedAt && this.formatDate(findOrder.updatedAt),
          paidAt: findOrder.createdAt && this.formatDate(findOrder.createdAt),
          progressingAt:
            findOrder.processingDate &&
            this.formatDate(findOrder.processingDate),
          fulfilledAt: findOrder.fulfilledAt || "",
          trackingNumber: findOrder.trackingNumber,
          trackingStatus: "",
          unitPrice: findOrder?.listSelectedProductId[0]?.price || 0,
          subTotal: findOrder.subTotal,
          shippingPrice: findOrder.shipping,
          discountPrice: findOrder.discount,
          totalAmount: findOrder.total,
          refund: 0,
          buyerName: `${findOrder.shippingAddress.firstName} ${findOrder.shippingAddress.lastName}`,
          email: findOrder.shippingAddress.email,
          shippingAddress1: address,
          shippingAddress2: apartment,
          shippingPhone: phoneNumber,
          shippingCity: city,
          shippingZip: zipCode,
          shippingProvince: this.findProvinceCode(state),
          shippingCountry: findCountry?.name || country,
          shippingCountryCode:
            findCountry?.code || this.findCountryCodeByCountry(country),
          shippingProvinceCode: state || "",
          paymentGateWayId: "",
          gatewayName: findOrder?.paymentId.name || "",
          gatewayType: payment,
          sellerEmail: findOrder?.sellerId?.email || "",
          domain: findOrder?.storeId?.domain || "",
          transactionId:
            findOrder?.paypal?.paymentID || findOrder?.stripe?.id || "",
        });
      } else {
        for (let i = 0; i < listSelectedProductId.length; i++) {
          const subTotal = _.sumBy(listSelectedProductId, "price");
          const product = listSelectedProductId[i];
          //@ts-ignore
          this.json_data.push({
            orderName: findOrder.orderCode,
            sku: product.sku || "",
            productName: product.productName || "",
            variantName: product.listValue.join(",") || "",
            quantity: product.quantity,
            itemStatus,
            deliveryStatus,
            lastStatusUpdatedAt:
              findOrder.updatedAt && this.formatDate(findOrder.updatedAt),
            paidAt: findOrder.createdAt && this.formatDate(findOrder.createdAt),
            progressingAt:
              findOrder.processingDate &&
              this.formatDate(findOrder.processingDate),
            fulfilledAt: findOrder.fulfilledAt || "",
            trackingNumber: findOrder.trackingNumber,
            trackingStatus: "",
            unitPrice: product?.price || 0,
            subTotal: i === 0 ? subTotal : 0,
            shippingPrice: i === 0 ? findOrder.shipping : 0,
            discountPrice: i === 0 ? findOrder.discount : 0,
            totalAmount: i === 0 ? findOrder.total : 0,
            refund: 0,
            buyerName: `${findOrder.shippingAddress.firstName} ${findOrder.shippingAddress.lastName}`,
            email: findOrder.shippingAddress.email,
            shippingAddress1: address,
            shippingAddress2: apartment,
            shippingPhone: phoneNumber,
            shippingCity: city,
            shippingZip: zipCode,
            shippingProvince: this.findProvinceCode(state),
            shippingCountry: findCountry?.name || country,
            shippingCountryCode:
              findCountry?.code || this.findCountryCodeByCountry(country),
            shippingProvinceCode: state || "",
            paymentGateWayId: "",
            gatewayName: "",
            gatewayType: payment,
            sellerEmail: findOrder?.sellerId?.email || "",
            domain: findOrder?.storeId?.domain || "",
            transactionId:
              findOrder?.paypal?.paymentID || findOrder?.stripe?.id || "",
          });
        }
      }
    }
  }
  total = 0;
  async onGetListOrder() {
    try {
      this.total = 0;
      this.loadingTable = true;
      const query = this.parseQuery();
      const response = await this.$api.order.getListOrder(query);
      if (response?.data) {
        const { total } = response.data;
        this.total = total;
        this.totalPage = Math.ceil(total / this.config.limit);
        this.listOrder = response.data.data;
      }
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loadingTable = false;
    }
  }

  async onGetListOrderExport() {
    try {
      this.loadingExport = true;
      const query = this.parseQuery();
      const response = await this.$api.order.getListExportOrder(query);
      if (response?.data) {
        this.listOrderExport = response.data;
      }
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loadingExport = false;
    }
  }

  async onExportFile() {
    await this.onGetListOrderExport();
    //@ts-ignore
    this.$refs.export.$el.click();
  }

  parseQuery() {
    const query: IQueryAdminAnalytics = {
      ...this.config,
      from: this.from,
      to: this.to,
      timezone: this.timezone,
    };
    if (this.isAbandonedMail) {
      query["isAbandon"] = true;
    }
    if (this.tab === 1) {
      query["storeId"] = this.storeId;
    }
    if (this.tab === 2) {
      query["productId"] = this.productId;
    }
    if (this.tab === 3) {
      query["sellerId"] = this.sellerId;
    }
    return query;
  }

  openDialogListOrder(id: string, name: string) {
    this.dialogFullScreen = true;
    if (this.tab === 1) {
      this.storeId = id;
    }
    if (this.tab === 2) {
      this.productId = id;
    }
    if (this.tab === 3) {
      this.sellerId = id;
    }
    this.name = name;
    this.onGetListOrder();
  }

  closeDialogListOrder() {
    this.dialogFullScreen = false;
    this.$reset();
  }

  onRedirectPage() {
    this.config.page = this.page;
    // this.onGetListOrder();
  }

  formatDate(date: string) {
    return this.$utils.formatDate(date, this.settings);
  }

  calcPcre(item: any) {
    return `${item["pc/re"].toFixed(2)}`;
  }

  convertImage(url: string) {
    return `${api}/${url}`;
  }

  linkProduct(slug: string) {
    const domain = window.location.host;
    return `${slug}.${domain}`;
  }

  findCountryCodeByCountry(country: string) {
    for (let item in jsonCountry) {
      if (jsonCountry[item] === country) {
        return item;
      }
    }
  }

  findProvinceCode(province: string) {
    const findProvince = jsonProvince.find(
      (item: any) => item.abbreviation === province
    );
    if (findProvince) {
      return findProvince.name;
    }
    return province;
  }

  @Watch("config.page")
  changedPage() {
    if (this.dialogFullScreen) {
      this.onGetListOrder();
    }
  }

  @Watch("dialogFullScreen")
  changedDialog(value: boolean) {
    if (!value) {
      this.setDestroy();
    }
  }
}
</script>

<style>
.border-dashed {
  border: 1px dashed #076ce3;
}
#scroll-list-order .v-data-table__wrapper {
  height: 85vh;
  overflow-y: auto;
}
@media screen and (max-width: 575px) {
  #scroll-list-order .v-data-table__wrapper {
    height: 70vh;
  }
}
/* @media screen and (min-width: 768px) {
  #scroll-list-order .v-data-table__wrapper {
    height: 960px !important;
  }
}
@media screen and (min-width: 1280px) {
  #scroll-list-order .v-data-table__wrapper {
    height: 1000px !important;
  }
}
@media screen and (min-width: 1920px) {
  #scroll-list-order .v-data-table__wrapper {
    height: 1280px !important;
  }
} */
</style>
